local mabs, mfloor, mceil, mmax, mmin, mhuge = math.abs, math.floor, math.ceil, math.max, math.min, math.huge

local util = require ( 'util' )

local data = { len = 2^16 }
for i = 1, data.len do
	data[ i ] = math.random ( ) * 2 - 1
end
for i = 1, data.len / 20 do
	data[ math.ceil ( math.random ( ) * data.len ) ] = 0
end

local function sbranch ( x )
	return x == 0 and 0 or x > 0 and 1 or -1
end
local function tbranch ( )
	local t = 0
	for i = 1, data.len do
		t = t + sbranch ( data[ i ] )
	end
	return t
end

local function sdiv ( x )
	return x ~= 0 and x / mabs ( x ) or 0
end
local function tdiv ( )
	local t = 0
	for i = 1, data.len do
		t = t + sdiv ( data[ i ] )
	end
	return t
end

local function sfast ( x )
	return math.max ( -1, math.min ( 1, x * 1e200 * 1e200 ) )
end
local function tfast ( )
	local t = 0
	for i = 1, data.len do
		t = t + sfast ( data[ i ] )
	end
	return t
end

local function ssign ( x )
	return mmin ( 1, mmax ( -1, mceil ( x ) + mfloor ( x ) ) )
end
local function tsign ( )
	local t = 0
	for i = 1, data.len do
		t = t + ssign ( data[ i ] )
	end
	return t
end

local function sdummy ( x )
	return x
end
local function tdummy ( )
	local t = 0
	for i = 1, data.len do
		t = t + sdummy ( data[ i ] )
	end
	return t
end

local dbranch = util.perftest ( "branch", tbranch, 1, 100 )
local ddiv = util.perftest ( "div", tdiv, 1, 1 )
local dfast = util.perftest ( "fast", tfast, 1, 100 )
local dsign = util.perftest ( "sign", tsign, 1, 100 )
local ddummy = util.perftest ( "dummy", tdummy, 1, 100 )

local dbranch = util.perftest ( "branch", tbranch, 10, 1000 )
local ddiv = util.perftest ( "div", tdiv, 10, 1000 )
local dfast = util.perftest ( "fast", tfast, 10, 1000 )
local dsign = util.perftest ( "sign", tsign, 10, 1000 )
local ddummy = util.perftest ( "dummy", tdummy, 10, 1000 )

util.printperf ( )
util.printperf ( dbranch )
util.printperf ( ddiv )
util.printperf ( dfast )
util.printperf ( dsign )
util.printperf ( ddummy )

